// **********************************************************************
//
// Copyright (c) 2003-2010 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.4.1

package IceGrid;

// <auto-generated>
//
// Generated from file `Query.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>


/**
 * The IceGrid query interface. This interface is accessible to
 * Ice clients who wish to look up well-known objects.
 * 
 **/
public final class QueryPrxHelper extends Ice.ObjectPrxHelperBase implements QueryPrx
{
    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @return The proxies or an empty sequence, if no such objects
     * have been found.
     * 
     **/
    public Ice.ObjectPrx[]
    findAllObjectsByType(String type)
    {
        return findAllObjectsByType(type, null, false);
    }

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxies or an empty sequence, if no such objects
     * have been found.
     * 
     **/
    public Ice.ObjectPrx[]
    findAllObjectsByType(String type, java.util.Map<String, String> __ctx)
    {
        return findAllObjectsByType(type, __ctx, true);
    }

    private Ice.ObjectPrx[]
    findAllObjectsByType(String type, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("findAllObjectsByType");
                __delBase = __getDelegate(false);
                _QueryDel __del = (_QueryDel)__delBase;
                return __del.findAllObjectsByType(type, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __findAllObjectsByType_name = "findAllObjectsByType";

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type)
    {
        return begin_findAllObjectsByType(type, null, false, null);
    }

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, java.util.Map<String, String> __ctx)
    {
        return begin_findAllObjectsByType(type, __ctx, true, null);
    }

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, Ice.Callback __cb)
    {
        return begin_findAllObjectsByType(type, null, false, __cb);
    }

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findAllObjectsByType(type, __ctx, true, __cb);
    }

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, Callback_Query_findAllObjectsByType __cb)
    {
        return begin_findAllObjectsByType(type, null, false, __cb);
    }

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllObjectsByType(String type, java.util.Map<String, String> __ctx, Callback_Query_findAllObjectsByType __cb)
    {
        return begin_findAllObjectsByType(type, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findAllObjectsByType(String type, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findAllObjectsByType_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findAllObjectsByType_name, __cb);
        try
        {
            __result.__prepare(__findAllObjectsByType_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.writeString(type);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The proxies or an empty sequence, if no such objects
     * have been found.
     * 
     **/
    public Ice.ObjectPrx[] end_findAllObjectsByType(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __findAllObjectsByType_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        Ice.ObjectPrx[] __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = Ice.ObjectProxySeqHelper.read(__is);
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public boolean
    findAllObjectsByType_async(AMI_Query_findAllObjectsByType __cb, String type)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllObjectsByType_name);
            __r = begin_findAllObjectsByType(type, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllObjectsByType_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find all the well-known objects with the given type.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    findAllObjectsByType_async(AMI_Query_findAllObjectsByType __cb, String type, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllObjectsByType_name);
            __r = begin_findAllObjectsByType(type, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllObjectsByType_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @return The proxies of each object replica or an empty sequence,
     * if the given proxy is not from a replica group.
     * 
     **/
    public Ice.ObjectPrx[]
    findAllReplicas(Ice.ObjectPrx proxy)
    {
        return findAllReplicas(proxy, null, false);
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxies of each object replica or an empty sequence,
     * if the given proxy is not from a replica group.
     * 
     **/
    public Ice.ObjectPrx[]
    findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx)
    {
        return findAllReplicas(proxy, __ctx, true);
    }

    private Ice.ObjectPrx[]
    findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("findAllReplicas");
                __delBase = __getDelegate(false);
                _QueryDel __del = (_QueryDel)__delBase;
                return __del.findAllReplicas(proxy, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __findAllReplicas_name = "findAllReplicas";

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy)
    {
        return begin_findAllReplicas(proxy, null, false, null);
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx)
    {
        return begin_findAllReplicas(proxy, __ctx, true, null);
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, Ice.Callback __cb)
    {
        return begin_findAllReplicas(proxy, null, false, __cb);
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findAllReplicas(proxy, __ctx, true, __cb);
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, Callback_Query_findAllReplicas __cb)
    {
        return begin_findAllReplicas(proxy, null, false, __cb);
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx, Callback_Query_findAllReplicas __cb)
    {
        return begin_findAllReplicas(proxy, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findAllReplicas(Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findAllReplicas_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findAllReplicas_name, __cb);
        try
        {
            __result.__prepare(__findAllReplicas_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.writeProxy(proxy);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The proxies of each object replica or an empty sequence,
     * if the given proxy is not from a replica group.
     * 
     **/
    public Ice.ObjectPrx[] end_findAllReplicas(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __findAllReplicas_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        Ice.ObjectPrx[] __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = Ice.ObjectProxySeqHelper.read(__is);
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     **/
    public boolean
    findAllReplicas_async(AMI_Query_findAllReplicas __cb, Ice.ObjectPrx proxy)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllReplicas_name);
            __r = begin_findAllReplicas(proxy, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllReplicas_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find all the object replicas associated with the given
     * proxy. If the given proxy is not an indirect proxy from a
     * replica group, an empty sequence is returned.
     * 
     * @param __cb The callback object for the operation.
     * @param proxy The object proxy.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    findAllReplicas_async(AMI_Query_findAllReplicas __cb, Ice.ObjectPrx proxy, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findAllReplicas_name);
            __r = begin_findAllReplicas(proxy, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findAllReplicas_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @return The proxy or null if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx
    findObjectById(Ice.Identity id)
    {
        return findObjectById(id, null, false);
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy or null if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx
    findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx)
    {
        return findObjectById(id, __ctx, true);
    }

    private Ice.ObjectPrx
    findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("findObjectById");
                __delBase = __getDelegate(false);
                _QueryDel __del = (_QueryDel)__delBase;
                return __del.findObjectById(id, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __findObjectById_name = "findObjectById";

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id)
    {
        return begin_findObjectById(id, null, false, null);
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx)
    {
        return begin_findObjectById(id, __ctx, true, null);
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, Ice.Callback __cb)
    {
        return begin_findObjectById(id, null, false, __cb);
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findObjectById(id, __ctx, true, __cb);
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, Callback_Query_findObjectById __cb)
    {
        return begin_findObjectById(id, null, false, __cb);
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, Callback_Query_findObjectById __cb)
    {
        return begin_findObjectById(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findObjectById(Ice.Identity id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findObjectById_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findObjectById_name, __cb);
        try
        {
            __result.__prepare(__findObjectById_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            id.__write(__os);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The proxy or null if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx end_findObjectById(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __findObjectById_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        Ice.ObjectPrx __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = __is.readProxy();
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     **/
    public boolean
    findObjectById_async(AMI_Query_findObjectById __cb, Ice.Identity id)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findObjectById_name);
            __r = begin_findObjectById(id, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findObjectById_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find a well-known object by identity.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    findObjectById_async(AMI_Query_findObjectById __cb, Ice.Identity id, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findObjectById_name);
            __r = begin_findObjectById(id, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findObjectById_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx
    findObjectByType(String type)
    {
        return findObjectByType(type, null, false);
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx
    findObjectByType(String type, java.util.Map<String, String> __ctx)
    {
        return findObjectByType(type, __ctx, true);
    }

    private Ice.ObjectPrx
    findObjectByType(String type, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("findObjectByType");
                __delBase = __getDelegate(false);
                _QueryDel __del = (_QueryDel)__delBase;
                return __del.findObjectByType(type, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __findObjectByType_name = "findObjectByType";

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public Ice.AsyncResult begin_findObjectByType(String type)
    {
        return begin_findObjectByType(type, null, false, null);
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, java.util.Map<String, String> __ctx)
    {
        return begin_findObjectByType(type, __ctx, true, null);
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, Ice.Callback __cb)
    {
        return begin_findObjectByType(type, null, false, __cb);
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findObjectByType(type, __ctx, true, __cb);
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, Callback_Query_findObjectByType __cb)
    {
        return begin_findObjectByType(type, null, false, __cb);
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectByType(String type, java.util.Map<String, String> __ctx, Callback_Query_findObjectByType __cb)
    {
        return begin_findObjectByType(type, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findObjectByType(String type, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findObjectByType_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findObjectByType_name, __cb);
        try
        {
            __result.__prepare(__findObjectByType_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.writeString(type);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx end_findObjectByType(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __findObjectByType_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        Ice.ObjectPrx __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = __is.readProxy();
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     **/
    public boolean
    findObjectByType_async(AMI_Query_findObjectByType __cb, String type)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findObjectByType_name);
            __r = begin_findObjectByType(type, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findObjectByType_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find a well-known object by type. If there are several objects
     * registered for the given type, the object is randomly
     * selected.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    findObjectByType_async(AMI_Query_findObjectByType __cb, String type, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findObjectByType_name);
            __r = begin_findObjectByType(type, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findObjectByType_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx
    findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample)
    {
        return findObjectByTypeOnLeastLoadedNode(type, sample, null, false);
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     * @return The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx
    findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx)
    {
        return findObjectByTypeOnLeastLoadedNode(type, sample, __ctx, true);
    }

    private Ice.ObjectPrx
    findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        int __cnt = 0;
        while(true)
        {
            Ice._ObjectDel __delBase = null;
            try
            {
                __checkTwowayOnly("findObjectByTypeOnLeastLoadedNode");
                __delBase = __getDelegate(false);
                _QueryDel __del = (_QueryDel)__delBase;
                return __del.findObjectByTypeOnLeastLoadedNode(type, sample, __ctx);
            }
            catch(IceInternal.LocalExceptionWrapper __ex)
            {
                __cnt = __handleExceptionWrapperRelaxed(__delBase, __ex, null, __cnt);
            }
            catch(Ice.LocalException __ex)
            {
                __cnt = __handleException(__delBase, __ex, null, __cnt);
            }
        }
    }

    private static final String __findObjectByTypeOnLeastLoadedNode_name = "findObjectByTypeOnLeastLoadedNode";

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample)
    {
        return begin_findObjectByTypeOnLeastLoadedNode(type, sample, null, false, null);
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx)
    {
        return begin_findObjectByTypeOnLeastLoadedNode(type, sample, __ctx, true, null);
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, Ice.Callback __cb)
    {
        return begin_findObjectByTypeOnLeastLoadedNode(type, sample, null, false, __cb);
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_findObjectByTypeOnLeastLoadedNode(type, sample, __ctx, true, __cb);
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, Callback_Query_findObjectByTypeOnLeastLoadedNode __cb)
    {
        return begin_findObjectByTypeOnLeastLoadedNode(type, sample, null, false, __cb);
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx, Callback_Query_findObjectByTypeOnLeastLoadedNode __cb)
    {
        return begin_findObjectByTypeOnLeastLoadedNode(type, sample, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_findObjectByTypeOnLeastLoadedNode(String type, LoadSample sample, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        __checkAsyncTwowayOnly(__findObjectByTypeOnLeastLoadedNode_name);
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __findObjectByTypeOnLeastLoadedNode_name, __cb);
        try
        {
            __result.__prepare(__findObjectByTypeOnLeastLoadedNode_name, Ice.OperationMode.Idempotent, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__os();
            __os.writeString(type);
            sample.__write(__os);
            __os.endWriteEncaps();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     * @param __ret (return value) The proxy or null, if no such object has been found.
     * 
     **/
    public Ice.ObjectPrx end_findObjectByTypeOnLeastLoadedNode(Ice.AsyncResult __result)
    {
        Ice.AsyncResult.__check(__result, this, __findObjectByTypeOnLeastLoadedNode_name);
        if(!__result.__wait())
        {
            try
            {
                __result.__throwUserException();
            }
            catch(Ice.UserException __ex)
            {
                throw new Ice.UnknownUserException(__ex.ice_name());
            }
        }
        Ice.ObjectPrx __ret;
        IceInternal.BasicStream __is = __result.__is();
        __is.startReadEncaps();
        __ret = __is.readProxy();
        __is.endReadEncaps();
        return __ret;
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     **/
    public boolean
    findObjectByTypeOnLeastLoadedNode_async(AMI_Query_findObjectByTypeOnLeastLoadedNode __cb, String type, LoadSample sample)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findObjectByTypeOnLeastLoadedNode_name);
            __r = begin_findObjectByTypeOnLeastLoadedNode(type, sample, null, false, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findObjectByTypeOnLeastLoadedNode_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    /**
     * Find a well-known object by type on the least-loaded node. If
     * the registry does not know which node hosts the object
     * (for example, because the object was registered with a direct proxy), the
     * registry assumes the object is hosted on a node that has a load
     * average of 1.0.
     * 
     * @param __cb The callback object for the operation.
     * @param type The object type.
     * 
     * @param sample The sampling interval.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public boolean
    findObjectByTypeOnLeastLoadedNode_async(AMI_Query_findObjectByTypeOnLeastLoadedNode __cb, String type, LoadSample sample, java.util.Map<String, String> __ctx)
    {
        Ice.AsyncResult __r;
        try
        {
            __checkTwowayOnly(__findObjectByTypeOnLeastLoadedNode_name);
            __r = begin_findObjectByTypeOnLeastLoadedNode(type, sample, __ctx, true, __cb);
        }
        catch(Ice.TwowayOnlyException ex)
        {
            __r = new IceInternal.OutgoingAsync(this, __findObjectByTypeOnLeastLoadedNode_name, __cb);
            __r.__exceptionAsync(ex);
        }
        return __r.sentSynchronously();
    }

    public static QueryPrx
    checkedCast(Ice.ObjectPrx __obj)
    {
        QueryPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (QueryPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::IceGrid::Query"))
                {
                    QueryPrxHelper __h = new QueryPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static QueryPrx
    checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        QueryPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (QueryPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                if(__obj.ice_isA("::IceGrid::Query", __ctx))
                {
                    QueryPrxHelper __h = new QueryPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static QueryPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        QueryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::IceGrid::Query"))
                {
                    QueryPrxHelper __h = new QueryPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static QueryPrx
    checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        QueryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA("::IceGrid::Query", __ctx))
                {
                    QueryPrxHelper __h = new QueryPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static QueryPrx
    uncheckedCast(Ice.ObjectPrx __obj)
    {
        QueryPrx __d = null;
        if(__obj != null)
        {
            try
            {
                __d = (QueryPrx)__obj;
            }
            catch(ClassCastException ex)
            {
                QueryPrxHelper __h = new QueryPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static QueryPrx
    uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        QueryPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            QueryPrxHelper __h = new QueryPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    protected Ice._ObjectDelM
    __createDelegateM()
    {
        return new _QueryDelM();
    }

    protected Ice._ObjectDelD
    __createDelegateD()
    {
        return new _QueryDelD();
    }

    public static void
    __write(IceInternal.BasicStream __os, QueryPrx v)
    {
        __os.writeProxy(v);
    }

    public static QueryPrx
    __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            QueryPrxHelper result = new QueryPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }
}
